﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SimpleVariables
{
    public partial class FormTestTypes : Form
    {
        //fields
        string strType = "";
        string strValue = "";
        string strResult = "";

        const string OK_MESSAGE =
                "Операция ввода прошла успешно!";
        const string ERR_MESSAGE =
            "Значение, заданное при вводе, не принадлежит типу ";
        const string ERR_Type_MESSAGE =
            "Неверно задан скалярный тип!";
        public FormTestTypes()
        {
            InitializeComponent();
            textBoxType.Select();
        }

        private void buttonInput_Click(object sender, EventArgs e)
        {
            strType = textBoxType.Text;
            strValue = textBoxValue.Text;
            
            //разбор вариантов
            switch (strType)
            {
                case "byte" :
                    { 
                        byte x;
                        try
                        {
                            x = Convert.ToByte(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "byte!"; 

                        }
                        break;
                    }
                case "bool":
                    {
                        bool x;
                        try
                        {
                            x = Convert.ToBoolean(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "bool!";

                        }
                        break;
                    }
                case "sbyte":
                    {
                        sbyte x;
                        try
                        {
                            x = Convert.ToSByte(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "sbyte!";

                        }
                        break;
                    }
                case "short":
                    {
                        short x;
                        try
                        {
                            x = Convert.ToInt16(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "short!";

                        }
                        break;
                    }
                case "ushort":
                    {
                        ushort x;
                        try
                        {
                            x = Convert.ToUInt16(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "ushort!";

                        }
                        break;
                    }
                case "int":
                    {
                        int x;
                        try
                        {
                            x = Convert.ToInt32(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "int!";

                        }
                        break;
                    }
                case "uint":
                    {
                        uint x;
                        try
                        {
                            x = Convert.ToUInt32(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "uint!";

                        }
                        break;
                    }
                case "long":
                    {
                        long x;
                        try
                        {
                            x = Convert.ToInt64(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "long!";

                        }
                        break;
                    }
                case "ulong":
                    {
                        ulong x;
                        try
                        {
                            x = Convert.ToUInt64(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "ulong!";

                        }
                        break;
                    }
                case "float":
                    {
                        float x;
                        try
                        {
                            x = Convert.ToSingle(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "float!";

                        }
                        break;
                    }
                case "double":
                    {
                        double x;
                        try
                        {
                            x = Convert.ToDouble(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "double!";

                        }
                        break;
                    }
                case "decimal":
                    {
                        decimal x;
                        try
                        {
                            x = Convert.ToDecimal(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "decimal!";

                        }
                        break;
                    }
                case "char":
                    {
                        char x;
                        try
                        {
                            x = Convert.ToChar(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "char!";

                        }
                        break;
                    }
                case "string":
                    {
                        string x;
                        try
                        {
                            x = Convert.ToString(strValue);
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "string!";

                        }
                        break;
                    }
                case "object":
                    {
                        object x;
                        try
                        {
                            x = strValue;
                            textBoxResult.Text = OK_MESSAGE;
                            strResult = x.ToString();
                        }
                        catch (Exception)
                        {
                            textBoxResult.Text = ERR_MESSAGE + "object!";

                        }
                        break;
                    }
                 default :
                    {
                        textBoxResult.Text = ERR_Type_MESSAGE;
                        break;
                    }
            }

        }

        private void buttonOutput_Click(object sender, EventArgs e)
        {
            if (textBoxResult.Text == OK_MESSAGE)
                textBoxOutputValue.Text = strResult;
            else textBoxOutputValue.Text = "";
            
        }

       
    }
}
